//+------------------------------------------------------------------+
//|                                            wilders dmi meter.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 3

//
//
//
//
//

extern string DmiTimeFrames        = "M1;M5;M15;M30;H1;H4;D1;W1;MN";
extern int    DmiLength            = 14;
extern double DmiAdxMaximum        = 30;
extern int    IndicatorMagicNumber =  1;
extern int    IndicatorWindow      =  0;
extern int    IndicatorCorner      =  3;
extern int    IndicatorXPosition   = 10;
extern int    IndicatorYPosition   = 10;
extern int    IndicatorSteps       = 30;
extern color  IndicatorTextColor   = LightGray;
extern color  IndicatorBackColor   = DimGray;
extern color  IndicatorStartColor  = OrangeRed;
extern color  IndicatorEndColor    = LimeGreen;
extern int    BoxWidth             = 50;
extern int    BoxHeight            = 8;

//
//
//
//
//

double DIp[];
double DIm[];
double ADX[];
double ADXR[];
double averageDIp[];
double averageDIm[];
double averageTR[];

//
//
//
//
//

string  identifierName;
string  indicatorFileName;
string  labels[];
int     periods[];
bool    calculating = false;
int     middle;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexStyle(2,DRAW_NONE);
      if (DmiTimeFrames == "calculate")
      {
         IndicatorBuffers(7);
         SetIndexBuffer(0,ADX);
         SetIndexBuffer(1,DIp);
         SetIndexBuffer(2,DIm);
         SetIndexBuffer(3,ADXR);
         SetIndexBuffer(4,averageDIp);
         SetIndexBuffer(5,averageDIm);
         SetIndexBuffer(6,averageTR);
            for (int k=0; k<7; k++) SetIndexEmptyValue(k,0.00);
            calculating = true; 
            return(0);
      }      

   //
   //
   //
   //
   //
      
   IndicatorCorner = MathMax(MathMin(IndicatorCorner, 3), 0);
   IndicatorSteps  = MathMax(MathMin(IndicatorSteps ,75),15);
      if (MathMod(IndicatorSteps,2)==0) IndicatorSteps++;
                               middle = IndicatorSteps/2;

   //
   //
   //
   //
   //
      
   DmiTimeFrames = StringTrimLeft(StringTrimRight(StringUpperCase(DmiTimeFrames)));
   if (StringSubstr(DmiTimeFrames,StringLen(DmiTimeFrames),1) != ";")
                    DmiTimeFrames = StringConcatenate(DmiTimeFrames,";");

   //
   //
   //
   //
   //                                   
            
   int s = 0;
   int i = StringFind(DmiTimeFrames,";",s);
   while (i > 0)
   {
      string current = StringSubstr(DmiTimeFrames,s,i-s);
      int    time    = stringToTimeFrame(current);
         if (time > 0) {
            ArrayResize(labels ,ArraySize(labels)+1);
            ArrayResize(periods,ArraySize(periods)+1);
                        labels[ArraySize(labels)-1] = timeFrameToString(time); 
                        periods[ArraySize(periods)-1] = time; }
                        s = i + 1;
                            i = StringFind(DmiTimeFrames,";",s);
   }
   indicatorFileName=WindowExpertName();
   identifierName    = "wdmimeter"+IndicatorMagicNumber+":";
   return(0);
}

//
//
//
//
//

int deinit()
{
   int identifierLength = StringLen(identifierName);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i); if (StringSubstr(name,0,identifierLength) == identifierName)
                                       ObjectDelete(name);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define distance 43

int start()
{
   if (calculating) { calculateDmi(); return(0); }

   //
   //
   //
   //
   //
   
   int totalTimeFrames=ArraySize(periods);
   
   //
   //
   //
   //
   //
   
   int xPosition = IndicatorXPosition+10;
   int angle     = 90;
   int displ     = 1;
         
         if (IndicatorCorner==0 || IndicatorCorner==3) angle = 270;
         if (IndicatorCorner==0 || IndicatorCorner==2) displ =   0;
               setElement("0+0",xPosition      ,IndicatorYPosition,IndicatorBackColor,"gggggggg","Webdings",10,angle);
               setElement("0+1",xPosition+displ,IndicatorYPosition,IndicatorTextColor,"  Wilders DMI "+DmiLength+"  ","Arial", 9,angle);
               xPosition++;
   
   //
   //
   //
   //
   //

   for (int t=0; t<totalTimeFrames; t++)
   {
      string label = labels[t];
      int    time  = periods[t];

      if (IndicatorCorner==1 || IndicatorCorner==3)
      {
         label = labels[totalTimeFrames-t-1];
         time  = periods[totalTimeFrames-t-1];
      }
         
      //
      //
      //
      //
      //
       
      double adx = iCustom(NULL,time,indicatorFileName,"calculate",DmiLength,0,0);
      double dip = iCustom(NULL,time,indicatorFileName,"calculate",DmiLength,1,0);
      double dim = iCustom(NULL,time,indicatorFileName,"calculate",DmiLength,2,0);

         adx = MathMin(DmiAdxMaximum,adx);
                  if (dim>dip) adx *= -1;
         adx += DmiAdxMaximum;

      //
      //
      //
      //
      //

      for (int i=0; i<IndicatorSteps; i++)
      {
         int    pos = i; if (IndicatorCorner==0 || IndicatorCorner==1) pos = IndicatorSteps-i-1;
         double value = (i+1)*2.0*DmiAdxMaximum/(IndicatorSteps+1);
         
         //
         //
         //
         //
         //
         
            if (i==middle)
            {
                setElement(t+"-"+i,xPosition+t*BoxWidth,IndicatorYPosition+pos*BoxHeight,gradientColor(i,IndicatorSteps,IndicatorStartColor,IndicatorEndColor));
                continue; 
            }                
            if (dip>dim)
            {
               if (i<middle) { setElement(t+"-"+i,xPosition+t*BoxWidth,IndicatorYPosition+pos*BoxHeight,IndicatorBackColor); continue; }
               if (adx>=value)
                     setElement(t+"-"+i,xPosition+t*BoxWidth,IndicatorYPosition+pos*BoxHeight,gradientColor(i,IndicatorSteps,IndicatorStartColor,IndicatorEndColor));
               else  setElement(t+"-"+i,xPosition+t*BoxWidth,IndicatorYPosition+pos*BoxHeight,IndicatorBackColor);       
            }
            else
            {
               if (i>middle) { setElement(t+"-"+i,xPosition+t*BoxWidth,IndicatorYPosition+pos*BoxHeight,IndicatorBackColor); continue; }
               if (adx<=value)
                     setElement(t+"-"+i,xPosition+t*BoxWidth,IndicatorYPosition+pos*BoxHeight,gradientColor(i,IndicatorSteps,IndicatorStartColor,IndicatorEndColor));
               else  setElement(t+"-"+i,xPosition+t*BoxWidth,IndicatorYPosition+pos*BoxHeight,IndicatorBackColor);
            }
      }
      
      //
      //
      //
      //
      //
      
      setElement(t+"-"+i,xPosition+t*BoxWidth+10,IndicatorYPosition+i*BoxHeight,IndicatorTextColor,label,"arial",10);
   }
   return(0);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//


void calculateDmi()
{
   int counted_bars=IndicatorCounted();
   int limit;

   if(counted_bars<0) return;
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-2);

   //
   //
   //
   //
   //

   double sf = (DmiLength-1.0)/DmiLength;
      for (int i=limit;i>=0;i--)
      {
         double currTR  = MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1]);
         double DeltaHi = High[i] - High[i+1];
	      double DeltaLo = Low[i+1] - Low[i];
         double plusDM  = 0.00;
         double minusDM = 0.00;
         
            if ((DeltaHi > DeltaLo) && (DeltaHi > 0)) plusDM  = DeltaHi;
            if ((DeltaLo > DeltaHi) && (DeltaLo > 0)) minusDM = DeltaLo;      
         
         //
         //
         //
         //
         //
         
            averageDIp[i] = sf*averageDIp[i+1] + plusDM;
            averageDIm[i] = sf*averageDIm[i+1] + minusDM;
            averageTR[i]  = sf*averageTR[i+1]  + currTR;

         //
         //
         //
         //
         //
                  
            DIp[i] = 0.00;                   
            DIm[i] = 0.00;                   
            if (averageTR[i] > 0)
               {              
                  DIp[i] = 100.00 * averageDIp[i]/averageTR[i];
                  DIm[i] = 100.00 * averageDIm[i]/averageTR[i];
               }            

            double DX;
               if((DIp[i] + DIm[i])>0) 
                    DX = 100*MathAbs(DIp[i] - DIm[i])/(DIp[i] + DIm[i]); 
               else DX = 0.00;
               ADX[i] = sf*ADX[i+1] + DX/DmiLength; 
//               if(ShowADXR)
//                      ADXR[i] = 0.5*(ADX[i] + ADX[i+DMI.Length]);
//         DIp[i] = 1;
      }   
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void setElement(string element, int x, int y, color ecolor=Silver, string text = "ggggggg", string fontname="Webdings", double fontsize = 5.5, int angle=0)
{
   string name = identifierName+element;
   ObjectCreate(name, OBJ_LABEL, IndicatorWindow, 0, 0);
      ObjectSet(name, OBJPROP_XDISTANCE, x);
      ObjectSet(name, OBJPROP_YDISTANCE, y);
      ObjectSet(name, OBJPROP_BACK, FALSE);
      ObjectSet(name, OBJPROP_CORNER, IndicatorCorner);
      ObjectSet(name, OBJPROP_ANGLE, angle);
      ObjectSetText(name, text, fontsize, fontname, ecolor);
}

//
//
//
//
//

color gradientColor(int step, int totalSteps, color from, color to)
{
   color newBlue  = getColor(step,totalSteps,(from & 0XFF0000)>>16,(to & 0XFF0000)>>16)<<16;
   color newGreen = getColor(step,totalSteps,(from & 0X00FF00)>> 8,(to & 0X00FF00)>> 8) <<8;
   color newRed   = getColor(step,totalSteps,(from & 0X0000FF)    ,(to & 0X0000FF)    )    ;
   return(newBlue+newGreen+newRed);
}
color getColor(int stepNo, int totalSteps, color from, color to)
{
   double step = (from-to)/(totalSteps-1.0);
   return(MathRound(from-step*stepNo));
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(iTfTable[i]);
                                                      return(0);
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}